world
	fps = FPS

	maxx = 20
	maxy = 15
	view = "20x15"

	turf = /turf/tabletop
	mob = /mob/controller

	hub = "Kaiochao.TabletopSimulator"
	hub_password = "hNgNk0tI2dQXYnyU"

	New()
		..()
		spawn for()
			sleep tick_lag
			for(var/entity/entity)
				entity.Update()

		for(var/n in 1 to 10)
			var entity/card/card = new (locate(3, 3, 1))
			card.step_x = rand(-32, 32)
			card.step_y = rand(-32, 32)

		for(var/n in 1 to 10)
			var entity/coin/coin = new (locate(19, 2, 1))
			coin.step_x = rand(-32, 32)
			coin.step_y = rand(-32, 32)

		new /entity/die (locate(19, 14, 1))
		new /entity/die (locate(20, 13, 1))

		for(var/n in 1 to 10)
			var entity/paper/paper = new (locate(3, 13, 1))
			paper.step_x = rand(-32, 32)
			paper.step_y = rand(-32, 32)

		new /entity/pencil { color = "black" } (locate(6, 14, 1))
		new /entity/pencil { color = "red" } (locate(7, 14, 1))
		new /entity/pencil { color = "green" } (locate(8, 14, 1))
		new /entity/pencil { color = "blue" } (locate(9, 14, 1))

client
	show_popup_menus = FALSE

	New()
		. = ..()
		color = "black"
		spawn(1) animate(src, color = null, time = 2)

turf/tabletop
	icon_state = "rect"
	color = rgb(200, 150, 100)

	DblClick(location, control, params)
		if(params2list(params)["right"])
			var new_color = input("", "Tabletop Color", color) as null|color
			if(!isnull(new_color))
				for(var/turf/tabletop/t)
					t.color = new_color

mob/player
	step_size = 4

	Login()
		client.perspective = EYE_PERSPECTIVE
		client.eye = locate(1, 1, 1)
		world << "<i>[key] connected"
		src << "Controls:"
		src << "* mouse - interact"
		src << "* q/e - rotate"
		src << "* r - recolor"
		src << "* i - change icon"
		src << "* c - clear paper"

	Logout()
		world << "<i>[key] disconnected"

	Stat()
		statpanel("Online")
		for(var/mob/player/p) stat(p)

	verb/say(t as text)
		set hidden = TRUE
		world << "<b>[key]</b>: [html_encode(t)]"