atom
	movable
		var
			_dx
			_dy

		proc
			// returns null if both arguments are false
			// returns TRUE if no integer pixel movement occurred, but decimal values changed
			// returns TRUE if integer pixel movement occurred and succeeded (passes the value of Move())
			// returns FALSE if integer pixel movement occurred and failed
			Translate(X, Y)
				if(!(X || Y)) return
				var rx, ry
				if(X)
					_dx += X
					rx = round(_dx, 1)
					_dx -= rx
				if(Y)
					_dy += Y
					ry = round(_dy, 1)
					_dy -= ry
				var s = step_size
				step_size = max(abs(rx), abs(ry)) + 1
				. = (rx || ry) ? Move(loc, dir, step_x + rx, step_y + ry) : TRUE
				step_size = s

			Project(D, A)
				return Translate(D*sin(A), D*cos(A))
