entity/coin
	parent_type = /entity/flippable

	icon_state = "oval"

	throw_speed = 30
	front_color = "white"
	back_color = "black"

	var thickness = 2

	Click(location, control, params)
		params2list(params)["right"] && Flip()

	Thrown()
		Toss()

	proc/Toss()
		Spin()

	proc/Spin()
		var matrix/shape = matrix(1, 0, 0, 0, thickness/32, 0)
		var angle = 0
		animate(src, transform = shape, time = flip_time)
		sleep flip_time

		icon_state = "rect"
		color = "gray"

		var start = angle, end = angle + rand(360, 3*360)
		for(var/n in start to end step 30)
			angle += 30
			transform = turn(shape, angle)
			sleep TICK_LAG

		icon_state = "oval"
		SetSide(prob(50))
		animate(src, transform = initial(transform), time = flip_time, flags = ANIMATION_LINEAR_TRANSFORM)
