physics
	var friction = 0.2

	var enabled = TRUE

	var tmp/velocity_x = 0
	var tmp/velocity_y = 0

	proc/Update(entity/E)
		if(velocity_x || velocity_y)
			E.Translate(velocity_x, velocity_y)

		if(friction)
			var s = 1 - friction
			velocity_x *= s
			velocity_y *= s
			if(abs(velocity_x) < 0.01) velocity_x = 0
			if(abs(velocity_y) < 0.01) velocity_y = 0

	proc/SqrSpeed()
		return velocity_x * velocity_x + velocity_y * velocity_y

	proc/Speed()
		return sqrt(velocity_x * velocity_x + velocity_y * velocity_y)
